

var var_requestCount=0;

// provide a simulation of the pre-firefox 3 SOAP API
var soapy =
{
	installed: true,
	header_versions: '',
	
	// PUBLIC METHODS
	SOAPCall: function()
	// DESCRIPTION: SOAP Call object - emulates pre-Firefox3 API
	{
		// PUBLIC PROPERTIES
		
		this.parameters = {};
		
		this.transportURI = "http://example.tld/rpc";
		
		this.actionURI = "uri:XULadmin";
		
		this.version = "1.0";
		
		this.method = "default";
		
		this.method_namespace_uri = null;
		
		this.timeout = 60;
		
		this.body = null;
		
		this.encoding = null;
		
		this.header = null;
		
		this.message = null;
		
		this.envelope = new soapy.SOAPEnvelope();
		
		// PUBLIC METHODS
		
		this.QueryInterface = function()
		{
			// NOT IMPLEMENTED
			// METHOD: DESCRIPTION
		}
		
		this.getHeaderBlocks = function()
		{
			// NOT IMPLEMENTED
			// METHOD: DESCRIPTION
		}
		
		this.Parameters = function()
		{
			// NOT IMPLEMENTED
			// METHOD: DESCRIPTION
		}
		
		this.invoke = function()
		{
			// NOT IMPLEMENTED
			// METHOD: DESCRIPTION: synchronous SOAP call 
			// note: this function will probably not be implemented
			
			return false;
			
			// but should return a SOAPResponse object really
		}
		
		this.asyncInvoke = function(callback_function)
		{
			// METHOD: DESCRIPTION: asynchronous SOAP call
			// make XMLHTTPRequest and assign a callback function
			
			// return nothing: run callback function on reply - callback function
			// has to provide 3 parameters - response (SOAPResponse, soapcall object - its own, 
			// error code -> != 0 -> error)
			
//			alert('callback_function=' + callback_function);
			
			soapy.AJAXCall(this, callback_function) 
		}
		
		this.rest_asyncInvoke = function(callback_function)
		{
			soapy.RESTCall(this, callback_function) 
		}
		
		this.encode = function(ver, my_method, namespace_uri, length_headers, headers, objects_length, array_of_objects)
		{
			// METHOD: encode an array of SOAPParameter objects to the envelope
			// METHOD: DESCRIPTION: encode stuff to the envelope
			
			// should provide: soap_version, method_name, object_uri, headers_length, headers
			//		params_length, params
			// soapCall.encode(0, method, "urn:GoogleSearch", 0, null, params.length, params);
			
			try
			{
				
				var mymethod = document.createElementNS(namespace_uri, my_method);
				// mymethod.setAttribute("xmlns", namespace_uri);
				
				for (var i = 0; i < array_of_objects.length; i++)
				{
					mymethod.appendChild(array_of_objects[i].e4x);
				}
				
				var body = this.envelope.getElementsByTagNameNS('http://schemas.xmlsoap.org/soap/envelope/','Body')[0];
				body.appendChild(mymethod);
				
				this.method = my_method;
				this.actionURI = namespace_uri;
				
			}catch(e){alert('[soap_core.js:soapy:SOAPCall:encode] ' + e)}
			
		}
		
	},

	// PUBLIC OBJECTS

	SOAPParameter: function(parameter_value_or_object,parameter_name)
	{
		// DESCRIPTION: a SOAP Parameter
		
		try {
			var value1 = parameter_value_or_object;
			
			var datatype = "xs:string";
			
			if (value1 == parseInt(value1))
			{
				datatype = "xs:int";
			}
			
			this.e4x = document.createElementNS("", parameter_name);
			
			this.e4x.setAttribute("xsi:type", datatype);
			
			var mydata = document.createTextNode(value1);
			
			this.e4x.appendChild(mydata);
			
			this.value = value1;
			
			this.name = parameter_name;
			
		}
		catch(e)
		{
			alert('[soap_core.js:soapy:SOAPParameter]' + e)
		}	
	},
	
	SOAPResponse: function (xml_object)
	{
		// properties: 
		
		this.method = null;
		this.version = null;
		
		// create clean DOM objects from soap envelope 
		
		this.body = soapy.cloneDocumentFragment(xml_object.getElementsByTagNameNS('http://schemas.xmlsoap.org/soap/envelope/','Body')[0], 'body');
		this.header = soapy.cloneDocumentFragment(xml_object.getElementsByTagNameNS('http://schemas.xmlsoap.org/soap/envelope/','Header')[0], 'header');
		
		//log('[SOAP] {SOAPResponse} header:' + new XMLSerializer().serializeToString(this.header));
		//log('[SOAP] {SOAPResponse} body:' + new XMLSerializer().serializeToString(this.body));
		//var encodedXML = new XMLSerializer().serializeToString(this.body);
		//alert(encodedXML);
		
		this.json_body = cyclone3xuladmin.JXON.convert_XML_JXON(this.body).body;
		this.json_header = cyclone3xuladmin.JXON.convert_XML_JXON(this.header).header;
	},
	
	SOAPFault: function(faultcode, faultstring)
	{
		// properties:
		
		this.faultCode = null;
		this.faultString = null;
		this.faultNamespaceURI = null;
		this.element = null;
		this.detail = null;
		
		var parser = new DOMParser();
		
		this.xmldom = new soapy.SOAPEnvelope();
		
		var body = this.xmldom.getElementsByTagNameNS('http://schemas.xmlsoap.org/soap/envelope/','Body')[0];
		
		var my_fault = document.createElement('Fault');
		var my_faultcode = document.createElement('faultcode');
		var my_faultstring = document.createElement('faultstring');
		var my_detail = document.createElement('detail');
		
		var my_faultcode_value = document.createTextNode(faultcode);
		var my_faultstring_value = document.createTextNode(faultstring);
		
		my_faultcode.appendChild(my_faultcode_value);
		my_faultstring.appendChild(my_faultstring_value);
		my_fault.appendChild(my_faultcode);
		my_fault.appendChild(my_faultstring);
		my_fault.appendChild(my_detail);
		
		body.appendChild(my_fault);
		
		this.body = soapy.cloneDocumentFragment(body.getElementsByTagNameNS('http://schemas.xmlsoap.org/soap/envelope/','Body')[0], 'body');
		this.header = soapy.cloneDocumentFragment(body.getElementsByTagNameNS('http://schemas.xmlsoap.org/soap/envelope/','Header')[0], 'header');
		
		this.json_body = cyclone3xuladmin.JXON.convert_XML_JXON(this.body).body;
		this.json_header = cyclone3xuladmin.JXON.convert_XML_JXON(this.header).header;
		
	},
	
	// PRIVATE METHODS
	
	SOAPEnvelope: function()
	{
		// PRIVATE FUNCTION
		try
		{
			
			var parser = new DOMParser();
			
			var doc = parser.parseFromString('<env:Envelope xmlns:env="http://schemas.xmlsoap.org/soap/envelope/" xmlns:enc="http://schemas.xmlsoap.org/soap/encoding/" env:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xs="http://www.w3.org/1999/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"><env:Header></env:Header><env:Body></env:Body></env:Envelope>', "text/xml")
			
			this.e4x = doc;	
			
		} catch(e){alert('[soap_core.js:soapy:SOAPEnvelope] ' + e)}
		return this.e4x;
	},
	
	AJAXCall: function(soapcall_object, callback_function)
	{
		// PRIVATE FUNCTION
		
		var encodedXML = new XMLSerializer().serializeToString(soapcall_object.envelope);
		
		var parameter_uri = soapcall_object.transportURI;
		var parameter_object_uri = soapcall_object.actionURI;
		var parameter_method = soapcall_object.method;
		
		var var_http_method = "POST";
		var var_charset = 'UTF-8';
		
		// should receive an e4x object and a callback function, as well as url
		// should pass some error messages to the callback function so we know what happened
		// before sending it will serialize the e4x
		
		try {if (window.XMLHttpRequest) 
		{
			
			var request = new XMLHttpRequest();
			
			request.onreadystatechange = function()
			{
				
				if (request.readyState == 4)
				{
					
					if (request.status == 404 && request.responseXML == null)
					{
						alert('404 - Not Found');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 401 && request.responseXML == null)
					{
						alert('401 - Unauthorized');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 500 && request.responseXML == null)
					{
//						alert('500 - Internal Server Error');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 500 && request.responseXML == null)
					{
//						alert('502 - Bad Gateway');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 503 && request.responseXML == null)
					{
//						alert('503 - Service Unavailable');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 504 && request.responseXML == null)
					{
//						alert('504 - Gateway Timeout');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 0 && request.responseXML == null)
					{
						alert('Can\'t connect to domain ' + parameter_uri);
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 200 || request.status == 404)
					{
						// call callback function and pass myself and request to it
						var response = new soapy.SOAPResponse(request.responseXML);
						if (typeof(callback_function.handleResponse) == 'function')
						{
							callback_function.handleResponse(response, soapcall_object, 0);
						}
						else
						{
							callback_function(response, soapcall_object, 0);
						}
					}	
					else
					{
						// something bad happened
						
						if (request.status == 0)
						{
							var statustext = "Could not connect to host!";
						}
						else
						{
							var statustext = request.statusText;
						}
						
						// generate a SOAPFault element
						var response_xml = new soapy.SOAPFault(request.status, statustext);
						
						// pass the response object to the callback function as usual
						
						if (typeof(callback_function.handleResponse) == 'function')
						{
							callback_function.handleResponse(response_xml, soapcall_object, 0);
						}
						else
						{
							callback_function(response_xml, soapcall_object, 0);
						}
						
						
						return false;
					}
					
				}
			}
			
			request.open(var_http_method, parameter_uri, true);
			
 			request.setRequestHeader('Content-Type','text/xml; charset=' + var_charset);
			request.setRequestHeader('SOAPAction', parameter_object_uri + '/' + parameter_method);
			request.setRequestHeader('C3-XULadmin-versions', soapy.header_versions);
			
			request.send(encodedXML);
			
		}} catch(e){'[soap_core.js:soapy:AJAXCall] ' + alert(e)}
		
	},
	
	RESTCall: function(restcall_object, callback_function)
	{
		// PRIVATE FUNCTION
		
		var encodedJSON = JSON.stringify(restcall_object.args);
		
		var parameter_uri = restcall_object.transportURI;
		
		var var_http_method = "POST";
		var var_charset = 'UTF-8';
		
		// should receive an e4x object and a callback function, as well as url
		// should pass some error messages to the callback function so we know what happened
		// before sending it will serialize the e4x
		
		try {if (window.XMLHttpRequest) 
		{
			
			var request = new XMLHttpRequest();
			
			request.onreadystatechange = function()
			{
				
				if (request.readyState == 4)
				{
					
					if (request.status == 404 && request.responseXML == null)
					{
						alert('404 - Not Found');
						callback_function.handleResponse(null, restcall_object, 0);
					}
					else if (request.status == 401 && request.responseXML == null)
					{
						alert('401 - Unauthorized');
						callback_function.handleResponse(null, restcall_object, 0);
					}
					else if (request.status == 500 && request.responseXML == null)
					{
//						alert('500 - Internal Server Error');
						callback_function.handleResponse(null, restcall_object, 0);
					}
					else if (request.status == 500 && request.responseXML == null)
					{
//						alert('502 - Bad Gateway');
						callback_function.handleResponse(null, restcall_object, 0);
					}
					else if (request.status == 503 && request.responseXML == null)
					{
//						alert('503 - Service Unavailable');
						callback_function.handleResponse(null, restcall_object, 0);
					}
					else if (request.status == 504 && request.responseXML == null)
					{
//						alert('504 - Gateway Timeout');
						callback_function.handleResponse(null, restcall_object, 0);
					}
					else if (request.status == 0 && request.responseXML == null)
					{
						alert('Can\'t connect to domain ' + parameter_uri);
						callback_function.handleResponse(null, restcall_object, 0);
					}
					else if (request.status == 200 || request.status == 404)
					{
						// call callback function and pass myself and request to it
						var response = new soapy.SOAPResponse(request.responseXML);
						if (typeof(callback_function.handleResponse) == 'function')
						{
							callback_function.handleResponse(response, restcall_object, 0);
						}
						else
						{
							callback_function(response, restcall_object, 0);
						}
					}
					else
					{
						// something bad happened
						
						if (request.status == 0)
						{
							var statustext = "Could not connect to host!";
						}
						else
						{
							var statustext = request.statusText;
						}
						
						// generate a SOAPFault element
						var response_xml = new soapy.SOAPFault(request.status, statustext);
						
						// pass the response object to the callback function as usual
						
						if (typeof(callback_function.handleResponse) == 'function')
						{
							callback_function.handleResponse(response_xml, restcall_object, 0);
						}
						else
						{
							callback_function(response_xml, restcall_object, 0);
						}
						
						
						return false;
					}
					
				}
			}
			
			log('[SOAP] {RESTCall} ' + parameter_uri + ' ' + encodedJSON);
			request.open(var_http_method, parameter_uri, true);
			
 			request.setRequestHeader('Content-Type','text/xml; charset=' + var_charset);
			request.setRequestHeader('C3-XULadmin-versions', soapy.header_versions);
			
			request.send(encodedJSON);
			
		}} catch(e){alert('[soap_core.js:soapy] {RESTCall} ' + e)}
		
	},
	
	// PRIVATE HELPER FUNCTIONS
	cloneDocumentFragment: function(fragment, root_node_name)
	{
		// creates a new document with a custom root tag name and clones all the document children
		
		var doc = (new DOMParser()).parseFromString("<" + root_node_name + "/>", 'text/xml');
		
		for (var i = 0; i < fragment.children.length; i++)
		{
			var new_node = fragment.children[i].cloneNode(true);
			doc.documentElement.appendChild(new_node);
		}
		
		return doc;
	}
}

core.getInstalledVersion(
	"c3xuladmin4@cyclone3.org", 
	function(addon)
	{
		var tmpApp = core.getAppVersion();
		soapy.header_versions = tmpApp.version + '/' + addon.version;
	}
);


/*
	
	Request Handler
	
*/

function SOAPh()
{}

// Request identificator string
SOAPh.prototype.var_id = "default";

//Request timeout threshold - milliseconds
SOAPh.prototype.var_timeout = 120000;

SOAPh.prototype.var_soapVersion  = 0; // Version 1.1
SOAPh.prototype.var_object       = "uri:XULadmin";
SOAPh.prototype.var_transport_URI = "http://example.tld/rpc/";

try
{
	if(window.arguments)
	{
		if ( window.arguments[0] && window.arguments[0].transport_URI )
		{
			SOAPh.prototype.var_transport_URI = window.arguments[0].transport_URI;
		}
	}
}catch(e){
//alert('[soap_core.js][SOAPh initialization] ' + e)
}

log('[SOAP] transport_URI='+SOAPh.prototype.var_transport_URI);

//SOAP calls pool
SOAPh.prototype.obj_requestPool = {};

//request-unique ordinal counter
SOAPh.prototype.var_requestOrdinal = 0;

//tracks the count of requests in progress
SOAPh.prototype.var_requestCount = 0;

//creates a new SOAP call, adds it to request pool and returns its handle
SOAPh.prototype.fnc_requestAdd = function()
{
	var tmpOrdinal = ++this.var_requestOrdinal;

	if (typeof(SOAPCall) == 'function') 
	{
		this.obj_requestPool['request'+tmpOrdinal] = new SOAPCall();
	} else 
	{
		this.obj_requestPool['request'+tmpOrdinal] = new soapy.SOAPCall();
	}

	var_requestCount++;
	log('[SOAP:'+this.var_id+'] {fnc_requestAdd} #' + tmpOrdinal + ' added to pool (' + var_requestCount + ' active)');
	
	if (document.getElementById('statusbar-icon'))
	{
		if (var_requestCount > 0)
		{
			window.setCursor('wait')
			document.getElementById('statusbar-icon').setAttribute('class','busy');
		}
		else
		{
			window.setCursor('auto')
			document.getElementById('statusbar-icon').setAttribute('class','ready');
		}
	}
	if (document.getElementById('statusbar-progress'))
	{
		if (var_requestCount > 1)
		{
			document.getElementById('statusbar-progress').setAttribute('collapsed', 'false');
		}
		document.getElementById('statusbar-progress').setAttribute('value', (var_requestCount * 10));
	}
	
	return {
		call: this.obj_requestPool['request'+tmpOrdinal],
		ordinal: tmpOrdinal
	};
},

//removes a finished SOAP call from request pool
SOAPh.prototype.fnc_requestDelete = function(SOAPRequestOrdinal)
{
	delete this.obj_requestPool['request'+SOAPRequestOrdinal];
	var_requestCount--;
	log('[SOAP:'+this.var_id+'] {fnc_requestDelete} #' + SOAPRequestOrdinal + ' removed from pool (' + var_requestCount + ' active)');
	
	if (document.getElementById('statusbar-icon'))
	{
		if (var_requestCount > 0)
		{
			window.setCursor('wait')
			document.getElementById('statusbar-icon').setAttribute('class','busy');
		}
		else
		{
			window.setCursor('auto')
			document.getElementById('statusbar-icon').setAttribute('class','ready');
		}
	}
	if (document.getElementById('statusbar-progress'))
	{
		document.getElementById('statusbar-progress').setAttribute('value', (var_requestCount * 10));
		if (var_requestCount < 1)
		{
			document.getElementById('statusbar-progress').setAttribute('collapsed', 'true');
		}
	}
	
	return true;
}

SOAPh.prototype.fnc_create = function (method_name, args)
{
	var handler = this;
	try
	{
		log('[SOAP:'+handler.var_id+'] {fnc_create} "' + method_name + '" ' + JSON.stringify(args));
		
		if (method_name==''){method_name = 'default';}
		
		var headers = new Array();
		
		var params  = new Array();
		
		for (var item in args)
		{
			if
			(
				(typeof(args[item])=="string")
				|| (typeof(args[item])=="number")
				|| (typeof(args[item])=="xml")
			)
			{
				if (typeof(SOAPCall) == 'function') 
				{
					params.push(new SOAPParameter(args[item],item));
				} else
				{
					params.push(new soapy.SOAPParameter(args[item],item));
				}
			}
		}
		
		var tmpRequest = this.fnc_requestAdd();
		var tmpCall = tmpRequest.call;
		var tmpOrdinal = tmpRequest.ordinal;
		
		tmpCall.transportURI = handler.var_transport_URI;
		
		tmpCall.actionURI = handler.var_object + "/" + method_name;
		
		tmpCall.encode(
			handler.var_soapVersion,
			method_name,
			handler.var_object,
			headers.length, headers,
			params.length, params
		);
		
		tmpCall.asyncInvoke(new gen_responseListener(this, tmpOrdinal));
		
		return null;
		
	}catch(e){alert('SOAP Error [fnc_init]: '+e)}
}


SOAPh.prototype.rest_call = function (rest_method, args)
{
	var handler = this;
	try
	{
		if (rest_method==''){rest_method = 'default';}
		
		log('[SOAP:'+handler.var_id+'] {rest_call} /' + rest_method);
		
		var tmpRequest = this.fnc_requestAdd();
		var tmpCall = tmpRequest.call;
		var tmpOrdinal = tmpRequest.ordinal;
		
		tmpCall.transportURI = handler.var_transport_URI + rest_method;
		tmpCall.args = args;
		tmpCall.rest_asyncInvoke(new gen_responseListener(this, tmpOrdinal));
		
		return null;
		
	}catch(e){alert('REST [rest_call]: ' + e)}
}


SOAPh.prototype.fnc_onResponse = function (header,body)
{
	log('[SOAP:'+this.var_id+'] {fnc_onResponse} >/dev/null');
}


/*
	
	Listener
	
*/


function gen_responseListener (parentObject, requestOrdinal)
{
	try
	{
		this.obj_parentObject = parentObject;
		this.var_requestOrdinal = requestOrdinal;
	}
	catch(e){alert('[soap_core.js][gen_responseListener] ' + e)}
}


gen_responseListener.prototype.handleResponse =  function (resp, call, status)
{
	try
	{
		if (resp === null)
		{
			resp = {
				'json_header': {
				},
				'json_body': {
					'response': {
					}
				}
			};
//			alert('is null');
//			var doc_header = new DOMParser().parseFromString('<header></header>', "text/xml");
//			var json_header = cyclone3xuladmin.JXON.convert_XML_JXON(doc_header);
			
//			var doc_body = new DOMParser().parseFromString('<body><response><method>'+call.method+'</method><result>0</result></response></body>', "text/xml");
//			var json_body = cyclone3xuladmin.JXON.convert_XML_JXON(doc_body);
			
			this.obj_parentObject.fnc_onResponse(resp.json_header,resp.json_body);
			return 1;
		}
		
//		log('[SOAP:'+this.obj_parentObject.var_id+'] {handleResponse}: ' + JSON.stringify(resp.json_body));
		
		// for now, turn off error checking
		
		// var ENV = new Namespace('http://schemas.xmlsoap.org/soap/envelope/');
		
		log('[SOAP:'+this.obj_parentObject.var_id+'] {handleResponse} ' + resp.json_header.request_code);
		
		if (resp.json_body.Fault)
		{
			/* When SOAP service is broken */
			window.openDialog(
				'chrome://c3xuladmin/content/soap_error.xul',
				'cyclone-dialog',
				'chrome,centerscreen,modal,resizable',
				{
					'request_code': resp.json_header.request_code,
					'method': resp.json_header['method'],
					'message': JSON.stringify(resp.json_body)
				}
			);	
		}
		else if (!resp.json_body.response)
		{
			/* When SOAP response is okay, but not contain any correct Cyclone3 info */
			window.openDialog(
				'chrome://c3xuladmin/content/soap_unavailable.xul',
				'cyclone-dialog',
				'chrome,centerscreen,modal',
				{
					// this is not required, the target window does not display anything anyway
					//'header': json_header,
					//'body': json_body
				}
			);
//			this.obj_parentObject.fnc_onResponse(resp.json_header,resp.json_body);
		}
		else if (resp.json_body.response['@result'] != '1')
		{
			if (resp.json_body.response['@type'] == 'login')
			{
				
				if (resp.json_body.response.reason && resp.json_body.response.reason.match(/cookies are disabled/))
				{
					
					var my_domain = 'http://' + resp.json_header['domain'] + '/';
					
					if (my_domain != call.transportURI)
					{
						// this should not be here at all
						//var e4x_header = new XML('<header><domain>'+ my_domain +'</domain></header>');
						//var e4x_body = new XML("<body><response type=\"login\" reason=\"domain_change\"><method>"+call.method+"</method><result>0</result></response></body>");
						
					}
					else
					{
						alert(ui.locale.getStringFromName('window.login.cookies_disabled'));
					}
					
				}
				else
				{
					/* Display a nice login incorrect message */
					alert(ui.locale.getStringFromName('window.login.login_incorrect'));
				}
			}
			else if (resp.json_body.response['@code'] == '301x01')
			{
				if (resp.json_body.response.reason)
				{
					/* Display a nice permissions incorrect message */
	//				alert(ui.locale.getStringFromName('301x01'));
					window.openDialog(
						'chrome://c3xuladmin/content/soap_alert.xul',
						'cyclone-dialog',
						'chrome,centerscreen,modal',
						{
							'request_code': resp.json_header.request_code,
							'method': resp.json_header['method'],
							'reason': resp.json_body.response.reason
						}
					);
				}
			}
			else
			{
				/* When service has been not correctly executed */
				window.openDialog(
					'chrome://c3xuladmin/content/soap_alert.xul',
					'cyclone-dialog',
					'chrome,centerscreen,modal',
					{
						'request_code': resp.json_header.request_code,
						'method': resp.json_header['method'],
						'reason': resp.json_body.response.reason
					}
				);
				// this.obj_parentObject.fnc_onResponse(e4x_header,e4x_body);
			}
			
			this.obj_parentObject.fnc_onResponse(resp.json_header, resp.json_body);
		}
		else
		{
			this.obj_parentObject.fnc_onResponse(resp.json_header, resp.json_body);
			
			try
			{
				cyclone3xuladmin.gen_SOAPBroadcaster.fnc_broadcast(resp.json_header, resp.json_body);
			}
			catch(e)
			{
				// no broadcaster detected
				alert('no broadcaster detected' + "\n" + e);
			}
		}
		
		//alert('finish');
		return true;
	}
	catch(e)
	{
		log('[SOAP]'+this.obj_parentObject.var_id+'] {handleResponse}: ' + e)
//		this.obj_parentObject.fnc_requestDelete(this.var_requestOrdinal)
	}
	finally
	{
		this.obj_parentObject.fnc_requestDelete(this.var_requestOrdinal)
	}
}

